% PSteepestDescentSolver (abstract subclass of IterativeSolver)  Solves nonsymmetric linear equations
%   iteratively by an optimally preconditioned steepest descent method.
%% NOTE: This is still a work in progress and not yet fully functional.

classdef PSteepestDescentSolver < IterativeSolver
    
    properties (Access=protected)
        C
        b
        residual
        Cresidual
        searchDirection
        normb
    end
    
    %% constructor
    methods (Access=public)
        function obj = PSteepestDescentSolver(preconditioner)
            arguments
                preconditioner (1,1) Preconditioner
            end
            
            obj = obj@IterativeSolver();
            obj.C = preconditioner;
        end
    end
    
    %% extend superclass methods
    methods (Access=public)
        function setupSystemMatrix(obj, A, symA)
            setupSystemMatrix@IterativeSolver(obj, A);
            obj.C.setup(symA);
        end
        
        function setupRhs(obj, b, varargin)
            setupRhs@IterativeSolver(obj, b, varargin{:});
            
            % initialize residual & search direction
            obj.b = b;
            obj.residual = b - obj.A * obj.x;
            obj.Cresidual = obj.C.apply(obj.residual);
            obj.searchDirection = obj.Cresidual;
            obj.normb = vecnorm(b, 2, 1);
        end
    end
    
    
    
    %% implement abstract superclass methods

end