% timeStep auxiliary function to update the time measurement and
% separately store the time step
%
%   [timepoint, steptime] = timeStep(timepoint) from given timepoint
%   returns the current timepoint and the time step since the last
%   measurement

function [timepoint, steptime] = timeStep(timepoint)

oldTimepoint = timepoint;
timepoint = posixtime(datetime);
steptime = timepoint - oldTimepoint;

end
